$debug
C----------------------------------------------------------------------
C	
$include	: 'L2D05.inc'
C
C
C
C	THIS PROGRAM SOLVES TWO DIMENSIONAL (PO) TENTIAL PROBLEMS
C	WITH (M)ULTIBOUNDARY DOMAINS USING (CON)STANT (B)OUNDARY (E)LEMENTS
C	IN PRESENCE OF INTERFACIAL IMPEDANCES
C	INTERFACE CONDITIONS
C
C
	CHARACTER*64 FILEIN,FILEOUT  
C
	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX)  ,CY(LMX) ,SOL(LMX)
	COMMON/MATG/   G(NMX,NMX)
C
C	ASSIGN NUMBERS FOR INPUT AND OUTPUT FILES
C
	INP=5
	IPR=6

      WRITE(*,'('' L2D05'')')

C
C	READ NAMES AND OPEN FILES FOR INPUT AND OUTPUT
C

      CALL GETFNAMES(FILEIN, FILEOUT)
	OPEN(5,FILE=FILEIN,STATUS='OLD')
	OPEN(6,FILE=FILEOUT,STATUS='UNKNOWN')
C
C	READ DATA
C
	CALL INPUMPC
C
C	COMPUTE THE GEOMETRICAL QUANTITIES OF INTEREST
C
	CALL GEOM
C
C	COMPUTE H AND G MATRICES AND FORM SYSTEM ( A X = F )
C
	write(*,'('' Now Calculating G and H'')')
	CALL GHMAMPC
C
C	SOLVE SYSTEM OF EQUATIONS
C
	Write(*,'('' Now Solving'')')
c      OPEN(10,file='F:L2D05.LOG',STATUS='UNKNOWN')
c      write(10,'(10F10.6,5X,3F10.6)')((G(I,J),J=1,10),DFI(i),FI(i),
c     &Zs(i),I=1,N)
c      CLOSE(10)

	CALL DPVT(G,DFI,N,1,NMX,1.d-5,ier)
	if(ier.ne.0)write(6,'('' **** IER NON ZERO IN DPVT :'',i4)')ier
C
C	COMPUTE POTENTIAL VALUES AT INTERNAL POINTS
C
	CALL REORDER
	CALL INTEMPC
C
C	PRINT RESULTS AT BOUNDARY NODES AND INTERNAL POINTS
C
	CALL OUTPMPC
c
c	Calcul et impression des flux
c
c	CALL OUTFLUX
      CALL CURRENT
C
C	CLOSE INPUT AND OUTPUT FILES
C
	CLOSE(INP)
	CLOSE(IPR)
	STOP
	END
C----------------------------------------------------------------------
	SUBROUTINE INPUMPC
C
C	PROGRAM 24
C
$include	: 'L2D05.inc'
C
	CHARACTER*80 TITLE
C
	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
C
C	N=NUMBER OF BOUNDARY NODES (=NUMBER OF ELEMENTS)
C	L=NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED.
C	M=NUMBER OF BOUNDARIES
C
C
	WRITE(6,100)
100	FORMAT(' ',79('*'))
C
C	READ JOB TITLE
C
	READ(5,'(A)') TITLE
	WRITE(6,'(A)') TITLE
C
C	READ NUMBER OF BOUNDARY ELEMENTS AND INTERNAL POINTS
C
	READ(5,*) NSX,NSY,N,L,M,(NC(K),K=1,M)
	
	IF(N.GT.NMX)THEN
	WRITE(*,'('' TOO MANY ELEMENTS :'',I4,''/'',I4,'' (maximum)'')')
     &      N, NMX
      STOP '*** FATAL ERROR ***'  
      ENDIF

	IF(L.GT.LMX)THEN
	WRITE(*,'('' TOO MANY INTERNAL POINTS :'',I4,
	&''/'',I4,'' (maximum)'')') L, LMX
      STOP '*** FATAL ERROR ***'  
      ENDIF

	IF(M.GT.MMX)THEN
	WRITE(*,'('' TOO MANY BOUNDARIES :'',I4,''/'',I4,'' (maximum)'')')
     &      M, MMX
      STOP '*** FATAL ERROR ***'  
      ENDIF
	  
	WRITE(6,300) N,L
300	FORMAT(//' DATA'//2X,'NUMBER OF BOUNDARY ELEMENTS =',i4/,2X,
     *	'NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED =',
     *	i4)
	WRITE(6,350) NSX,NSY
350	FORMAT(//2X,'X-SYMMETRY=',I2,2X,'Y-SYMMETRY=',I2)
C
	IF(M)40,40,30
30	WRITE(6,999)M,(NC(K),K=1,M)
999	FORMAT(/2X,'NUMBER OF DIFFERENT BOUNDARIES =',i4/2X,
     *	'LAST NODE OF EACH BOUNDARY =',5(i4,','))
C
C
C	READ COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY ELEMENTS
C	IN ARRAYS X AND Y
C
40	WRITE(6,500)
500	FORMAT(//2X,'COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY',
     *	' ELEMENTS',//1X,'POINT',7X,'X',15X,'Y')
	READ(5,*) (X1(I),Y1(I),I=1,N+M)
	DO 10 I=1,N+M
10	WRITE(6,700) I,X1(I),Y1(I)
700	FORMAT(2X,i4,2(2X,1pE14.5))
C
C	READ BOUNDARY CONDITIONS IN F(I) VERTOR, IF KODE(I)=0 THE FI(I)
C	VALUE IS A KNOWN POTENTIAL;IF KODE(I)=1 THE FI(I) VALUE IS A
C	KNOWN POTENTIAL DERIVATIVE (FLUX).
C
	WRITE(6,800)
800	FORMAT(//2X,'BOUNDARY CONDITIONS'//2X,'NODE',6X,'CODE',7X,
     *	'PRESCRIBED VALUE',5X,'INT.IMPEDANCE / EPS')
	DO 20 I=1,N
	READ(5,*) KODE(I)
	BACKSPACE(5)
	IF(KODE(I).LE.0.OR.KODE(I).EQ.1)THEN
	ZS(I) = 0.
	READ(5,*) KODE(I),FI(I)
	WRITE(6,950)I,KODE(I),FI(I)
	ELSEIF(KODE(I).EQ.2)THEN
	READ(5,*) KODE(I),FI(I),ZS(I)
	WRITE(6,950)I,KODE(I),FI(I),ZS(I)
	ELSEIF(KODE(I).EQ.3)THEN
	READ(5,*) KODE(I),EPS(I)
	FI(I) = 0.d0
	WRITE(6,950)I,KODE(I),FI(I),EPS(I)
	ELSE
	WRITE(6,'('' UNKNOWN CODE AT I='',i4,'' KODE ='',i4/)')I,KODE(I)
	STOP'*** JOB ABORTED ***'
	ENDIF
950	FORMAT(2X,i4,8X,I2,8X,1pE14.5,8X,E14.5)
20	CONTINUE
C
C	READ COORDINATES OF INTERNAL POINTS
C
	IF(L.EQ.0) GOTO 50
	READ(INP,*) (CX(I),CY(I),I=1,L)
50	CONTINUE
C
C	CHECK FOR ZERO NORMAL GRADIENT CONTITION 
C	
C	DO 55 I = 1 , N
C55	IF ( FI(I) .EQ. 0  ) KODE(I) = KODE (I) + 2	
	END

$page
C----------------------------------------------------------------------
	SUBROUTINE GEOM
C
C	CALCULATE THE GEOMETRICAL ELEMENTS OF THE BOUNDARIES
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
C
C	
C
	IB = 1
      J1 = 1
      J2 = 1
	DO 100 IB = 1 , M
C     
C     Beginning and ending indexes to boundary IB
C
      IF (IB.EQ.1) then
      I1 = 1
      I2 = NC(1)
      else
      I1 = NC(IB-1)+1
      I2 = NC(IB)
      endif
c      
      DO 102 I = I1 ,I2-1
      X2(J2) = X1(I+1)
      Y2(J2) = Y1(I+1)
      J2 = J2 + 1 
102   continue
      
      DO 103 I = I1, I2-1
      X1(J1) = X1(I)
      Y1(J1) = Y1(I)
      J1 = J1 + 1
103   continue
C
100   continue

C
      DO 101 J1 = 1, N
C
C       MID POINT, SLOPE, LENGHT
C
	XM( J1 ) = .5d0 * ( X1(J1) + X2(J1) )
	YM( J1 ) = .5d0 * ( Y1(J1) + Y2(J1) )
C
	DX = X2(J1) - X1(J1)
	DY = Y2(J1) - Y1(J1) 
C
	S( J1 )  = DSQRT ( DX * DX + DY * DY )
C
	TX ( J1 ) =  DX / S ( J1 )
	TY ( J1 ) =  DY / S ( J1 ) 
C
C       NEXT POINT
C       
101   CONTINUE
	END     
C----------------------------------------------------------------------
	SUBROUTINE GHMAMPC
C
C	PROGRAM 25
C
C	THIS SUBROUTINE	COMPUTES THE H AND G MATRICES
C	AND FORMS THE SYTEM OF EQATIONS A X = F
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
	COMMON/MATG/ G(NMX,NMX)
C
C     EXAMINES SYMMETRIES
C
      IF(NSX.EQ.0)THEN
      ISX = 1                   
      ELSE
      ISX = -1
      ENDIF
            	
      IF(NSY.EQ.0)THEN
      ISY = 1
      ELSE
      ISY = -1
      ENDIF
C
C	COMPUTE THE COEEFICIENTS OF G AND H MATRICES
C
	DO 200 I = 1 , N
	DFI(I) = 0.d0
C
	DO 100 J = 1 , N
	 
      G1 =   0.D0
      IF(I.EQ.J) THEN
	IF(KODE(I).LE.2)THEN
	H1 =  -.5D0
	ELSEIF(KODE(I).EQ.3)THEN
	H1 = -.5D0 * (1.d0 + EPS(I))
	ENDIF
      ELSE
      H1 = 0.D0
      ENDIF
      
      DO IX = ISX, 1, 2
      KX = 1
      IF( IX .EQ. -1) KX = NSX

      DO IY = ISY, 1, 2
      KY = 1
      IF( IY .EQ. -1) KY = NSY
      
      CALL INFL2D( IX*XM(I), IY*YM(I), J, G2, H2 )

	IF (KODE(J).EQ.3) H2 = H2 * (1.d0 - EPS(J) )

      G1 = G1 +  KX * KY * G2
      H1 = H1 +  KX * KY * H2   
           
      ENDDO
      ENDDO


C
C	REORDER THE COLUMNS OF THE SYSTEM IN ACCORDANCE
C	WITH THE BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX A WHICH
C	IS STORED IN G
C
	IF ( KODE(J). EQ . 1 ) THEN 
C
	H      = - G1
	G(I,J) = - H1
C
	ELSEIF (KODE(J).EQ.2) THEN
C
	H      = H1 
	G(I,J) = G1 + ZS(J) * H1
C
	ELSEIF (KODE(J).EQ.3) THEN
C
	H      = 0.d0
	G(I,J) = - H1 
C	
	ELSEIF (KODE(J).LE.0) THEN
C
	H      = H1 
	G(I,J) = G1
C
	ENDIF
C
C	FORM THE RIGHT HAND SIDE VECTOR F WHICH IS STORED IN DFI
C
	DFI(I) = DFI(I) + H * FI(J)
C
C	NEXT POINT
C	
100	CONTINUE
C
C	NEXT LINE
C
200	CONTINUE
	END
$page
	SUBROUTINE INFL2D( XP, YP, j, G1, H1)
C
C
C	THIS SUBROUTINE	COMPUTES H AND G COEFFICIENTS 
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
	COMMON/MATG/ G(NMX,NMX)
	
	data init/0/
	if(init.eq.0)then
	init=1
	Pi = 4.d0 * DATAN (1.d0)
	uns4pineg = -.25d0/Pi
	uns2pi    =   .5d0/Pi
	endif
C
C	COMPUTE THE COEEFICIENTS OF G AND H COEFFICIENTS
C
C
	U1    =    XP - X1(J) 
	V1    =    YP - Y1(J) 
	XX1   = - (U1 * TX(J) + V1 * TY(J))		
	XX2   =    XX1 + S(J)
	YY    =    U1 * TY(J) - V1 * TX(J)
	YY2   =    YY*YY

	IF(XP.EQ.XM(J).AND.YP.EQ.YM(J)) THEN 
	AT    = 0.E0
	ELSE
      AT    =  DATAN2 ( YY*(XX1-XX2), XX1*XX2+YY2 )
	ENDIF

	H1 = uns2pi    *  AT
	G1 = uns4pineg *( XX1*DLOG(XX1*XX1+YY2) - XX2*DLOG(XX2*XX2+YY2)
     &	                +2.D0 * YY * AT + 2.D0 * S(J))

	END
$page
C----------------------------------------------------------------------
	SUBROUTINE REORDER
C
C	PROGRAM 26
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
C
C	REARRANGE THE FI AND DFI ARRAYS TO STORE ALL THE VALUES OF THE
C	POTENTIAL IN FI AND ALL THE VALUES OF THE DERIVATIVE IN DFI
C
	DO 20 I=1,N
	IF(KODE(I).EQ.1) THEN
	CH=FI(I)
	FI(I)=DFI(I)
	DFI(I)=CH
	ELSEIF(KODE(I).EQ.2) THEN
	FI(I) = FI(I) - ZS(I) * DFI(I)
	ELSEIF(KODE(I).EQ.3) THEN
	CH=DFI(I)
	FI(I)=CH
	DFI(I)=0.d0
	ENDIF
20	CONTINUE
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE INTEMPC
C
C	PROGRAM 26
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
	COMMON/GEOXRT2/SOLX(LMX),SOLY(LMX)	
	DEL = 1.0d-4
C
C
C
	IF(L.EQ.0) RETURN
	DO 40 K=1,L
	CALL POTENT(CX(K),CY(K),SOL(K))
 	CALL POTENT(CX(K)+DEL,CY(K),SOLX(K))
	CALL POTENT(CX(K),CY(K)+DEL,SOLY(K))
	SOLX(K)=(SOLX(K)-SOL(K))/DEL
40	SOLY(K)=(SOLY(K)-SOL(K))/DEL
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE POTENT(X0,Y0,F)
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
C
C	COMPUTE THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
C
C
C     EXAMINES SYMMETRIES
C
	F = 0.d0

	IF(NSX.EQ.0)THEN
      ISX = 1
      ELSE
      ISX = -1
      ENDIF
            	
      IF(NSY.EQ.0)THEN
      ISY = 1
      ELSE
      ISY = -1
      ENDIF
C
C	COMPUTE THE COEEFICIENTS OF G AND H MATRICES
C
	DO J = 1 , N

      G1 = 0.D0
      H1 = 0.D0
      
      DO IX = ISX, 1, 2
      KX = 1
      IF( IX .EQ. -1) KX = NSX

      DO IY = ISY, 1, 2
      KY = 1
      IF( IY .EQ. -1) KY = NSY
      
      CALL INFL2D( IX*X0, IY*Y0, J, G2, H2 )

	IF(KODE(J).EQ.3) H2 = H2 * ( 1.d0 - EPS(J) )

      G1 = G1 +  KX * KY * G2
      H1 = H1 +  KX * KY * H2   
           
      ENDDO
      ENDDO
C
	F = F + H1 * FI(J) - G1 * DFI(J)
      
      ENDDO 
C
	END

C----------------------------------------------------------------------
	SUBROUTINE OUTPMPC
C
C	PROGRAM 27
C
C	THIS SUBROUTINE PRINTS THE VALUES OF THE POTENTIAL AND ITS NORMAL
C	DERIVATIVE AT BOUNDARY NODES. IT ALSO PRINTS THE VALUES OF THE
C	POTENTIAL AT INTERNAL POINTS
C

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
	COMMON/GEOXRT2/SOLX(LMX), SOLY(LMX)	
C
	WRITE(6,100)
100	FORMAT(' ',79('*')//1X,'RESULTS'//2X,'BOUNDARY NODES'//' NODE',
     &10X,'X',15X,'Y',13X,'S',
     &13X,'POTENTIAL',3X,'POTENTIAL DERIVATIVE'/)
	CURV = S(1)/2.d0
	DO 10 I=1,N
	IF(KODE(I).EQ.3)THEN
	WRITE(6,200) I,XM(I),YM(I),CURV,FI(I)
	ELSE
	WRITE(6,200) I,XM(I),YM(I),CURV,FI(I),DFI(I)
	ENDIF
	CURV = CURV + .5d0*(S(I)+S(I+1)) 
10	CONTINUE
200	FORMAT(I5,5(2X,1Pe14.5))
C
	IF(L.EQ.0) GOTO 30
	WRITE(6,300)
300	FORMAT(//,2X,'INTERNAL POINTS',//8X,'X',15X,'Y',13X,
     *	'POTENTIAL',8X,'GRADV-X',9X,'GRADV-Y'/)
	DO 20 K=1,L
20	WRITE(6,400)CX(K),CY(K),SOL(K),SOLX(K),SOLY(K)
400	FORMAT(5(2X,1Pe14.5))
30	WRITE(6,500)
500	FORMAT(' ',79('*'))
	RETURN
	END
$page
C----------------------------------------------------------------------
	subroutine  outflux
c
c	Calcul des flux sur les portions a Potentiel impose Kode=0
c

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
c
	WRITE(6,'(/'' FLUX''//)')
c
	init=0
	i=1
100	if(i.gt.N) goto 200
c
 	if(kode(i).eq.1)then	

	if(init.eq.0) then
	i=i+1
	goto 100
	endif
	if(init.eq.1) then
	i2=i-1
c
	WRITE(6,'('' FLUX :'',i4,''-'',i4,'' :'',1Pe12.5)')
     1	        i1,i2,flux
	init=0
	i=i+1
	goto 100
	endif
c
	else
	if(init.eq.0)then
	init=1
	I1=i
	flux=S(i)*dfi(i)
	else
	flux=flux+S(i)*dfi(i)
	endif
c
	i=i+1
	goto 100
c
	endif
c
200	CONTINUE
	IF(init.eq.1)THEN
	WRITE(6,'('' FLUX :'',i4,''-'',i4,'' :'',1Pe12.5)')
     1	        i1,N,flux
	ENDIF
	WRITE(6,500)
500	FORMAT(' ',79('*'))
	end
C----------------------------------------------------------------------
      SUBROUTINE GETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

      na = nargs()

      if(na.ge.2) then
      call getarg(1,FILEIN,ncar)
	WRITE(*,'('' NAME OF INPUT FILE : '',a)')FILEIN(1:ncar)
      else
	WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN
      IF(FILEIN.eq.' ') FILEIN = 'L2D05.IN'            
	endif


      if(na.ge.3) then
      call getarg(2,FILEOUT,ncar)
	WRITE(*,'('' NAME OF OUTPUT FILE : '',a)')FILEOUT(1:ncar)
      else
	WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
	READ(*,'(A)')FILEOUT
      IF(FILEOUT.eq.' ') FILEOUT = 'L2D05.OUT'            
	endif

	WRITE(*,'(\)')

      END      
C----------------------------------------------------------------------
      SUBROUTINE XXXGETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

	WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN

	WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
	READ(*,'(A)')FILEOUT

      END      
C----------------------------------------------------------------------
	subroutine  CURRENT
c
c	Calcul des flux sur les portions a Potentiel impose Kode<0
c

$include	: 'L2D05.inc'

	COMMON/GEO/    N,L,NC(MMX),M,INP,IPR,NSX,NSY
	COMMON/GEOXY1/ X1(NMX1),Y1(NMX1),X2(NMX),Y2(NMX),
     1	              XM(NMX) ,YM(NMX) ,FI(NMX),DFI(NMX)
	COMMON/GEOXY2/ KODE(NMX),S(NMX),TX(NMX),TY(NMX),ZS(NMX),EPS(NMX)
	COMMON/GEOXTR/ CX(LMX),CY(LMX),SOL(LMX)
c
      do 101 i=1,NMX
101   SOL(i) = 0
c
      JMAX = 0
c
      DO 100 i=1,N

      if(kode(i).lt.0)then    
      j = -Kode(i)
      Sol(j) = Sol(j) + S(i)*dfi(i)
      jmax = max0(jmax,j)
      endif
      
100   continue
      if(jmax.ne.0) then
      WRITE(6,'(/'' CURRENTS''/)')
      do 200 j=1, jmax
      WRITE(6,'('' FLUX'',i4,'' :'',1Pe12.5)')j,sol(j)
      WRITE(*,'('' FLUX'',i4,'' :'',1Pe12.5)')j,sol(j)
200   continue
      WRITE(6,500)
500   FORMAT(' ',79('*'))
      endif
	end
