set terminal postscript eps color solid "Times-Roman" 18
set output 'Test2d13.eps'
set title ""
set xlabel "Abscise curviligne"
set ylabel "V et derivee normale de V"
#set ylabel "Erreur sur la derivee normale de V"
set key right bottom
set samples 512
n = 2 ; eps=.5 ; a=.5
A1 = (1+eps)/((1+eps)+(1-eps)*a**(2*n))
B = (1-eps)*a**(2*n)/((1+eps)+(1-eps)*a**(2*n))
C = 2/((1+eps)+(1-eps)*a**(2*n))

f(s) = (s<pi) ? (A1 + B) *cos(n*s) : (A1*a**n+B/a**n)*cos(n*(pi-(s-pi)/a))
g(s) = (s<pi) ? n*(A1-B)*cos(n*s) : 0/0
h2(r,t)= (A1*r**n+B/r**n)*cos(n*t)
h(x,y)= h1(sqrt(x**2+y**2),atan2(y,x))
h1(r,t)= (t<pi) ? h2(r,t) : 0/0

plot \
'L2D05.out'   every :::2::2 using (atan2($2,$1)):($3) title  "V int., L2D05" with points 3,\
h1(0.75,x) title 'Analytic' with lines 3,\
'L2D05.out'  every :::5::5 using ($4):($5)  title  "V, L2D05" with points 1,\
f(x) title  "Analytic" with lines 1,\
'L2D05.out'  every :::5::5 using ($4):($6)  title  "dV/dn, L2D05" with points 2,\
g(x) title  "Analytic" with lines 2

